import { world } from "@minecraft/server";

world.afterEvents.playerPlaceBlock.subscribe(async (event) => {
    const player = event.player; 
    const block = event.block;
    const blockPos = block.location;

    if (block.typeId === "zc:vjar") {
        try {
            await player.runCommandAsync(`summon zc:cage_villager ${blockPos.x} ${blockPos.y} ${blockPos.z}`);
            await player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"\nLower Part For §eTrading\n §fUpper Part For §eBreaking\n §fHit them for §eRefresh"}]}`);
        } catch (error) {
            console.error(`Failed to summon entity: ${error}`);
        }
    }
});

world.afterEvents.playerBreakBlock.subscribe(async (event) => {
    const player = event.player;
    const block = event.block;   
    const blockPos = block.location; 

    if (block.typeId === "zc:vjar") {
        try {
            await player.runCommandAsync(`kill @e[type=zc:cage_villager,x=${blockPos.x},y=${blockPos.y},z=${blockPos.z},r=1]`);
        } catch (error) {
            console.error(`Failed to kill entity: ${error}`);
        }
    }
});







world.afterEvents.playerPlaceBlock.subscribe(async (event) => {
    const player = event.player; 
    const block = event.block;
    const blockPos = block.location;

    if (block.typeId === "zc:lvjar") {
        try {
            await player.runCommandAsync(`summon zc:librarian ${blockPos.x} ${blockPos.y} ${blockPos.z}`);
            await player.runCommandAsync(`tellraw @s {"rawtext":[{"text":"\n §fUpper Part For §eBreaking\n §fHit Lower Part For §eTrading"}]}`);
        } catch (error) {
            console.error(`Failed to summon entity: ${error}`);
        }
    }
});

world.afterEvents.playerBreakBlock.subscribe(async (event) => {
    const player = event.player;
    const block = event.block;   
    const blockPos = block.location; 

    if (block.typeId === "zc:lvjar") {
        try {
            await player.runCommandAsync(`kill @e[type=zc:librarian,x=${blockPos.x},y=${blockPos.y},z=${blockPos.z},r=1]`);
        } catch (error) {
            console.error(`Failed to kill entity: ${error}`);
        }
    }
});
