import { ActionFormData } from '@minecraft/server-ui';
import { world } from '@minecraft/server';

function showVanillaUI(player) {
    const ui = new ActionFormData()
        .title("Enchantment Menu")
        .body("§aYou need 30 Emeralds for each enchantment.\n§eHold the item you want to enchant!")
        .button("§l§5Sharpness V", "textures/items/book_enchanted")
        .button("§l§5Looting III", "textures/items/book_enchanted")
        .button("§l§5Unbreaking III", "textures/items/book_enchanted")
        .button("§l§5Protection IV", "textures/items/book_enchanted")
        .button("§l§5Depth Strider III", "textures/items/book_enchanted")
        .button("§l§5Feather Falling IV", "textures/items/book_enchanted")
        .button("§l§5Frost Walker II", "textures/items/book_enchanted")
        .button("§l§5Respiration III", "textures/items/book_enchanted")
        .button("§l§5Soul Speed III", "textures/items/book_enchanted")
        .button("§l§5Thorns III", "textures/items/book_enchanted")
        .button("§l§5Swift Sneak III", "textures/items/book_enchanted")
        .button("§l§5Efficiency V", "textures/items/book_enchanted")
        .button("§l§5Fire Aspect II", "textures/items/book_enchanted")
        .button("§l§5Infinity I", "textures/items/book_enchanted")
        .button("§l§5Silk Touch", "textures/items/book_enchanted")
        .button("§l§5Fortune III", "textures/items/book_enchanted")
        .button("§l§5Mending", "textures/items/book_enchanted")
        .button("§l§5Wind Burst III", "textures/items/book_enchanted");

    ui.show(player).then(async (response) => {
        if (response.canceled || response.selection === undefined) return;

        const enchantments = [
            "sharpness 5", "looting 3", "unbreaking 3", "protection 4", "depth_strider 3",
            "feather_falling 4", "frost_walker 2", "respiration 3", "soul_speed 3", "thorns 3",
            "swift_sneak 3", "efficiency 5", "fire_aspect 2", "infinity 1", "silk_touch 1",
            "fortune 3", "mending 1", "wind_burst 3"
        ];

        const enchantCmd = `enchant @s[hasitem={item=emerald,quantity=30..}] ${enchantments[response.selection]}`;
        const clearCmd = `clear @s[hasitem={item=emerald,quantity=30..}] emerald 0 30`;

        const enchantResult = await player.runCommandAsync(enchantCmd);

        if (enchantResult.successCount > 0) {
            await player.runCommandAsync(clearCmd);
            player.sendMessage("§aEnchantment successful! 30 emeralds used.");
        } else {
            player.sendMessage("§cFailed! You must be holding a valid item and have at least 30 emeralds.");
        }
    });
}


world.afterEvents.entityHitEntity.subscribe((data) => {
    const player = data.damagingEntity;
    const target = data.hitEntity;

    if (target?.typeId === "zc:librarian" && player?.typeId === "minecraft:player") {
        showVanillaUI(player);
    }
});
