import { world, system } from "@minecraft/server";
import { ActionFormData, ModalFormData } from '@minecraft/server-ui';

function mainTick() {
    for (const dimension of world.getDimensions()) {
        for (const block of dimension.getEntities({ type: "minecraft:block" })) {
            if (block.typeId === "zc:vjar") {
                const blockLocation = block.location;
                const belowBlockLocation = {
                    x: blockLocation.x,
                    y: blockLocation.y - 1,
                    z: blockLocation.z,
                };

                const belowBlock = dimension.getBlock(belowBlockLocation);

                
                if (belowBlock && belowBlock.typeId === "minecraft:air") {
                    dimension.runCommandAsync(
                        `setblock ${blockLocation.x} ${blockLocation.y} ${blockLocation.z} air destroy`
                    ).catch((error) =>
                        console.warn("Error destroying zc:pjar block:", error)
                    );
                }
            }
        }
    }

    system.run(mainTick);
}

system.run(mainTick);












world.afterEvents.entityHitEntity.subscribe((data) => {
    const targetEntity = data.hitEntity;
    const damager = data.damagingEntity;
    
    if (targetEntity && targetEntity.typeId === "zc:cage_villager" && damager && damager.typeId === "minecraft:player") {
        const form = new ActionFormData();
        form.title("Villager Refresh");
        form.button("Refresh");
        form.button("Cancel");
        
        form.show(damager).then((response) => {
            if (response.selection === 0) {
                damager.runCommandAsync(`execute @e[type=zc:cage_villager,c=1] ~~~ tp @s 0 -80 0`);
                damager.runCommandAsync(`summon zc:cage_villager ${targetEntity.location.x} ${targetEntity.location.y} ${targetEntity.location.z}`);
            }
        });
    }
});