import { world } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {

  initEvent.blockComponentRegistry.registerCustomComponent("zc_vjar:trigger", {

    onTick: (e) => {
      const block = e.block;
      if (!block) return;

      const blockLocation = block.location;
      const dimension = e.dimension;


      dimension
        .runCommandAsync(
          `fill ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z} ${blockLocation.x} ${blockLocation.y - 1} ${blockLocation.z} zc:airtest2 0 replace air`
        )
        .catch((error) => console.warn("Error filling zc:airtest2 block:", error));
    },


    onPlayerDestroy: (e) => {
      const block = e.block;
      if (!block) return;

      const blockLocation = block.location;
      const x = blockLocation.x;
      const y = blockLocation.y;
      const z = blockLocation.z;


      e.player
        .runCommandAsync(
          `execute @e[type=zc:cage_villager,x=${x},y=${y},z=${z},r=1.3] ~~~ tp @s 0 -80 0`
        )
        .catch((error) => console.warn("Error teleporting entity:", error));
        
        e.player
        .runCommandAsync(
          `execute @e[type=zc:librarian,x=${x},y=${y},z=${z},r=1.3] ~~~ tp @s 0 -80 0`
        )
        .catch((error) => console.warn("Error teleporting entity:", error));

      e.player
        .runCommandAsync(`summon villager ${x} ${y} ${z}`)
        .catch((error) => console.warn("Error summoning piglin:", error));
    },


    onPlayerInteract: (e) => {
      const block = e.block;
      if (!block) return;

      const blockLocation = block.location;
      const x = blockLocation.x;
      const y = blockLocation.y;
      const z = blockLocation.z;


      e.player
        .runCommandAsync(
          `execute @s[hasitem={item=goldd_ingot,location=slot.weapon.mainhand}] ~~~ loot spawn ${x} ${y + 1} ${z} loot "entities/gold_ingot"`
        )
        .catch((error) => console.warn("Error spawning loot:", error));


      e.player
        .runCommandAsync(
          `execute @s[hasitem={item=ggold_ingot,location=slot.weapon.mainhand}] ~~~ clear @s gold_ingot 0 1`
        )
        .catch((error) => console.warn("Error clearing gold ingot:", error));
    },
  });
});


world.beforeEvents.worldInitialize.subscribe((initEvent) => {
  initEvent.blockComponentRegistry.registerCustomComponent("zc_airtest:trigger2", {
    onTick: (e) => {
      const block = e.block;
      if (!block) return;

      const blockLocation = block.location;
      const dimension = block.dimension;

      const x = blockLocation.x;
      const y = blockLocation.y;
      const z = blockLocation.z;
      
      
        dimension
        .runCommandAsync(`execute @e[type=zc:librarian,x=${x},y=${y},z=${z},r=1] ~~~ tp @s 0 -80 0`)
        .catch((error) => console.warn("Error summoning piglin:", error));

      dimension
        .runCommandAsync(`setblock ${x} ${y} ${z} air replace`)
        .catch((error) => console.warn("Error destroying zc_airtest block:", error));

      
      dimension
        .runCommandAsync(
          `setblock ${blockLocation.x} ${blockLocation.y+1} ${blockLocation.z} air destroy`
        )
        .catch((error) => console.warn("Error teleporting entity:", error));
      
      dimension
        .runCommandAsync(
          `setblock ${blockLocation.x} ${blockLocation.y} ${blockLocation.z} air`
        )
        .catch((error) => console.warn("Error teleporting entity:", error));
      dimension
        .runCommandAsync(
          `execute @e[type=zc:cage_villager,x=${x},y=${y},z=${z},r=1.3] ~ ~ ~ summon villager ${x} ${y} ${z}`
        )
        .catch((error) => console.warn("Error teleporting entity:", error));
       

      
      dimension
        .runCommandAsync(`execute @e[type=zc:cage_villager,x=${x},y=${y},z=${z},r=0.5] ~~~ tp @s 0 -80 0`)
        .catch((error) => console.warn("Error summoning piglin:", error));
    },
  });
});

